#ifndef CAM_H
#define CAM_H

void cam_init();
void cam_wait_for_done();
void cam_get_information();
void cam_reset_to(int value);
void cam_set_edge(int modeEW, int modeNS, int value);
void cam_load_column(unsigned int value, unsigned int times);
void cam_load_big_column(const char *column, unsigned int times);
void cam_run(unsigned int generations);
void cam_shift_column(unsigned int times);
void cam_set_mask(unsigned int fullRow, unsigned int fullCol, unsigned int value, unsigned int maskX, unsigned int maskY);
void cam_set_rule(unsigned int key, unsigned int value);
void cam_set_wolfram_rule(unsigned int rule);
void cam_set_wolfram_rule_ns(unsigned int rule);
void cam_set_rule_from_array(unsigned char *rule_array);
unsigned int cam_read_output(int index);
unsigned int cam_get_row(unsigned int row);
void cam_get_full_row(unsigned int row, unsigned int *dst);
void cam_print_grid();
void cam_print_grid_rotated();
unsigned int cam_get_height();
unsigned int cam_get_width();
unsigned int cam_get_num_neighbours();
void cam_create_multi_gen();
void cam_load_single_north_east_1();
void cam_load_full_grid(const char *dst);
void cam_get_full_grid(char *dst);
char *cam_allocate_grid_array();
// Conway's Game of Life
void set_rule_to_game_of_life();

// Helper functions
void hex2bin(unsigned int hex, char *result, int size, int prioritize_msb);
unsigned int bin2hex(char *hex, int size);

#endif
