#ifndef TESTS_H
#define TESTS_H

// Verify that a reset to 0 produces all 0.
int test_reset_to_0();
// Verify that a reset to 1 produces all 1.
int test_reset_to_1();
// Test rule 30 as a pseudorandom number generator
void test_random_rule_30(int num_numbers);
// Test expanding rule 0-255 with multigen. 
void test_wolfram_rules_multigen();
// Test rule 0-255 for a specified amount of generations (printing only final result)
void test_wolfram_rules(int generations);
// Test Density classification (with internal rule 30 creation of pseudorandom numbers)
void test_density_classification_rule_184_232_ns()
// Test Density classification with rule 30 based rand()
int test_density_classification_rule_184_232_ns_r30rand();
// Test Density classification with rule 30 based rand() multiple times.
void test_density_184_232_n_times(unsigned int times)
// Conway's Game of Life:
// Test Gospel Glider for a specified number of generations, printing only the final generation.
void test_gospel_glider_print_final_only(int generations);
// Test Gospel Glider for a specified number of generations, printing every generation.
void test_gospel_glider_all_generations(int generations);

// Load some of the examples used in Gardner's Scientific American-article on Game of Life
void load_gardner_examples();
// Load the Gosper Glider gun
void load_gosper_glider_gun();


#endif
