#include <vector>
#include <string>
#include "rules.h"
#include "utils.h"


int countNeighbours(std::string str) {
	int neighbours = 0;
	for (size_t i = 0; i < str.size(); i++) {
		if (i == 4) {
			continue;
		}
		if (str[i] == '1') {
			neighbours++;
		}
	}
	return neighbours;
}

int calculateNextState(std::string currState) {
	int alive = (currState[4] == '1' ? 1 : 0);
	int neighbours = countNeighbours(currState);
	if (alive) {
		if (neighbours < 2) {
			return 0;
		} else if (neighbours == 2 || neighbours == 3) {
			return 1;
		} else {
			return 0;
		}
	} else {
		if (neighbours == 3) {
			return 1;
		} else {
			return 0;
		}
	}
}

Rules *generateGameOfLifeRules() {
	std::vector<std::string> temp;
	generateAllPossibleStrings(temp, "", 8);
	Rules *rule = new Rules();
	for (unsigned int i = 0; i < temp.size(); i++) {
		int nextState = calculateNextState(temp[i]);
		rule->addRule(temp[i], nextState);
	}
	
	return rule;
}
