#ifndef UTILS_H
#define UTILS_H

#include <string>
#include <vector>

/**
 * Creates a 1D-Array, and initializes all fields to 0.
 * @param width the width of the array
 * @param height the height of the array
 */
int *create1DArray(int width, int height);
/**
 * Creates a 2D-Array, and initializes all fields to 0.
 * @param width the width of the array
 * @param height the height of the array
 */
int **create2DArray(int width, int height);
/**
 * Calculates the 1D-index into an array from 2D-coordinates.
 * @param x the x coordinate
 * @param y the y coordinate
 * @param width the width of a row in the array
 * @return index usable for a 1D array
 */
unsigned int get1DIndex(unsigned int x, unsigned int y, unsigned int width);
void print1DArray(int *array, unsigned int width, unsigned int height);
void generateAllPossibleStrings(std::vector<std::string> &result, std::string prefix, int depth);
std::vector<std::string> tokenizeString(const std::string& str, const std::string& splitSyms);
int bin2dec(const std::string &str);
std::string int2bin(int value, int numBits);
std::string trimWhiteSpace(const std::string &str);
std::string trimComments(const std::string &str);
#endif
