#include <vector>
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <cstdlib>
#include <cassert>

using namespace std;

// Note, this tool works in low-to-high order
int main(int argc, char **argv) {
	if (argc <= 4) {
		cout << "Usage: flat2lst inputfile numRows outputFile" << endl;
		return -1;
	}
	string inFilename = argv[1];
	string outFilename = argv[3];
	int numRows = atoi(argv[2]);
	ifstream file;
	file.open(argv[1]);
	if (!file.good()) {
		cout << "Couldn't open file: " << argv[1] << endl;
		return -1;
	}
	string line;
	vector<string> lines;
	int i = -1;
	while (getline(file, line)) {
		lines.push_back(line);
		if (i > 0) {
			assert(lines[i].size() == lines[i - 1].size());
		}
		i++;
	}
	assert(lines.size() % numRows == 0);
	file.close();

	ofstream outfile(outFilename);
	if (!outfile.good()) {
		cout << "Couldn't open file: " << argv[1] << endl;
		return -1;
	}
	int numLines = lines.size() / numRows;
	int lineIndex = 0;
	// Dummy header
	outfile << "DUMMY" << endl << "HEADER" << endl;
	for (int i = 0; i < numLines; i++) {
		outfile << i << " " << i << " "; // Just an increasing number to get usefull fake ps-values.
		for (int j = 0; j < numRows; j++) {
			outfile << lines[lineIndex++];
			if (j != numRows - 1) {
				outfile << " ";
			}
		}
		outfile << endl;
	}


}

