#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <exception>

using namespace std;

int main(int argc, char** argv) {
	if (argc < 2) {
		cout << "Error: please supply a file" << endl;
		return -1;
	}

	ifstream infile(argv[1]);
	if (!infile.good()){
		cout << "Couldn't open " << argv[1] << endl;
		return -1;
	}

	vector<string> lines;
	unsigned long longestLine = 0;
	while (!infile.eof()) {
		string line;
		getline(infile, line);
		lines.push_back(line);
		longestLine = max(longestLine, line.size());
	}

	vector<string> flipped;
	for (int i = 0; i < longestLine; i++) {
		string line = "";
		for (auto it = lines.begin(); it != lines.end(); ++it) {
			char symbol;
			try {
				symbol =  it->at(i);
			} catch (std::exception &e) {
				symbol = ' ';
				// See if I care.
			}
			line += symbol;
		}
		flipped.push_back(line);
	}

	struct keyValue {
		string key;
		int value;
	};
	vector<keyValue> reduced;
	string lastString = "";
	for (auto it = flipped.begin(); it != flipped.end(); ++it) {
		if (*it == lastString) {
			reduced.back().value++;
		} else {
			keyValue k;
			k.key = *it;
			k.value = 1;
			reduced.push_back(k);
			lastString = *it;
		}
	}

	for (auto it = reduced.begin(); it != reduced.end(); ++it) {
		cout << "OPCODE(31 downto 29) <= (OP_LOADCOL);" << endl;
		cout << "OPCODE(28 downto 14) <= \"" << it->key << "\";" << endl;
		cout << "OPCODE(28 - 15 downto 28 - 15 - 7) <= conv_std_logic_vector("<<it->value<<",8);" << endl;
		cout << endl;
	}

	return 0;
}
