#include <vector>
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <cstdlib>

using namespace std;

// Note, this tool works in low-to-high order
int main(int argc, char **argv) {
	if (argc <= 1) {
		cout << "No input filename given" << endl;
		return -1;
	}
	int numItems = 0;
	if (argc >= 3) {
		numItems = atoi(argv[2]);
	}
	ifstream file;
	file.open(argv[1]);
	if (!file.good()) {
		cout << "Couldn't open file: " << argv[1] << endl;
		return -1;
	}
	string prevPs = "";
	vector<string> data;
	while (!file.eof()) {
		string line;
		getline(file, line);
		stringstream ss;
		ss.str(line);
		// Discard 2 "words" from the line:
		string item, ps;
		ss >> ps;
		if (ps != prevPs) {
		//	cout << ps << endl;
			// This has to happen in reverse order, as ModelSim seems to output low to high
			for (int i = data.size() - 1; i >= 0; i--) {
				cout << data[i] << endl;
			}
			cout << endl;
		}
		data.clear();
		prevPs = ps;
		ss >> item;
		int itemCount = 0;
		while (!ss.eof()) {
			ss >> item;
			if (ss.fail()) {
				break;
			}
			string output = "";
			for (int i = 0; i < item.size(); i++) {
				char c = item.at(i);
				if (isdigit(c) || c == 'X' || c == 'Z') {
					output += c;
				}
			}
			if (numItems && itemCount < numItems) {
//				cout << output << endl;
				data.push_back(output);
				itemCount++;
			} else if (numItems) {
				break;
			}
		}
	}
	for (int i = 0; i < data.size(); i++) {
		cout << data[i] << endl;
	}
}

