#include <iostream>
#include <string>
#include <fstream>
#include <sstream>
#include <cmath>

using namespace std;

int binStringToInt(string binString) {
	int result = 0;
	for (int i = binString.size() - 1; i >= 0; i--) {
		if (binString.at(i) == '1') {
			result += pow(2, 7 - i);
		}
	}
	return result;
}

int main(int argc, char **argv) {
	if (argc == 1) {
		cout << "No filename supplied" << endl;
		return -1;
	}
	fstream file;
	file.open(argv[1]);
	if (!file.good()) {
		cout << "Couldn't open file " << argv[1] << endl;
		return -1;
	}
	string line;
// Handle header: (ModelSim .lst-files have 2 lines of header preceding the data)
/*	getline(file, line);
	cout << line << endl;
	getline(file, line);
	cout << line << endl;*/
	string ps = "0";
	string prevPs = "-1";
	string prevRule = "";
	string delta = "";
	string state = "";
	string key = "";
	while (!file.eof()) {
		stringstream ss;
		getline(file, line);
		while (line.size() && (line.at(line.size() - 1) == 10 || line.at(line.size() - 1) == 13)){
			line.erase(line.size() - 1, 1);
		}
		bool skipLine = false;
		for (int i = 0; i < line.size(); i++) {
			if (line.at(i) == ' ' || line.at(i) == '\t') {
				continue;
			}
			if (isdigit(line.at(i))) {
				break;
			}
			skipLine = true;
			break;
		}
		if (skipLine) {
			cout << line << endl;
			continue;
		}
		ss.str(line);
		ss >> ps;
		ss >> delta;
		ss >> state;
		if (!ss.eof()) {
			string rule;
			ss >> rule;
			if (rule != prevRule) {
				if (rule.size() == 8) {
					cout << "-- Rule " << binStringToInt(rule) << endl;
				} else {
					cout << "-- Rule " << rule << endl;
				}
			}
			prevRule = rule;
		}
		if (ps != prevPs) {
			cout << state << endl;
		}
		prevPs = ps;
	}

	return 0;
}
